$e = 2.718;
cancel($EffingMagnetTick);
function effingmagnetTick()
{
	cancel($EffingMagnetTick);
	for(%i = 0; %i < clientGroup.getCount(); %i++) {
		%client = clientGroup.getObject(%i);
		if(isobject(%client.effingMagnet) && %client.effingMagnetActive) EffingMagnetWork(%client.effingMagnet);
	}
	$EffingMagnetTick = schedule(50, 0, "effingmagnetTick");
}
effingMagnetTick();

registerOutputEvent(fxDtsBrick, becomeOwnersEffingMagnet, "float 0.1 10 0.1 1");
registerOutputEvent(fxDtsBrick, toggleOwnersEffingMagnet, "bool 1");

function fxDTSBrick::becomeOwnersEffingMagnet(%this, %mag)
{
	%cl = getbrickgroupfromobject(%this).client;
	if(isObject(%cl)) %cl.effingMagnet = %this;
	%this.effingResidualInduction = (%this.getdatablock().brickSizeX * 0.5) * (%this.getdatablock().brickSizeY * 0.5) * (%this.getdatablock().brickSizeZ * 0.2) * %mag;
	%this.effingThickness = msqrt(mPow(%this.getdatablock().brickSizeX * 0.5, 2) + mPow(%this.getdatablock().brickSizeY * 0.5, 2) + mPow(%this.getdatablock().brickSizeZ * 0.2, 2))/2;
	%this.effingResidualInduction -= %this.effingThickness;
	%halflife = %this.effingThickness / 2;
	%this.effingDecayConstant = mLog(2) / %halflife;
	%this.effingRadius = (%halflife * 5) + %this.effingThickness;
}

function fxDTSBrick::toggleOwnersEffingMagnet(%this, %bool)
{
	%cl = findClientByBL_ID(%this.stackBL_ID);
	if(isObject(%cl)) %cl.effingMagnetActive = %bool;
}

function EffingMagnetWork(%brick)
{
	initContainerRadiusSearch(%brick.position, %brick.effingRadius + 3.5, $TypeMasks::VehicleObjectType); //3.5 is like, the size of a jeep, about
	while(%obj = containerSearchNext()) {
		%dist = vectorDist(%obj.getposition(), %brick.position) - %this.effingThickness - 3.5;
		if(%dist < 0) %dist = 0;
		%vec = vectorNormalize(VectorSub(%brick.position, %obj.getposition()));
		%flux = %brick.effingResidualInduction * mPow($e, -1 * %brick.effingDecayConstant * %dist);
		%flux *= 10; //arbitrary adjustment
		%ticpos = vectorAdd(%obj.getposition(), vectorScale(%obj.getvelocity(), 0.05));
		%topaccel = vectorlen(vectordist(%ticpos, %brick.position));
		if(%topaccel < %flux) %flux = %topaccel;
		%obj.addVelocity(VectorScale(%vec, %flux));
	}
}

//I can't believe this isn't already in the game
function Vehicle::AddVelocity(%this, %vel)
{
	%this.SetVelocity(vectorAdd(%this.getVelocity(), %vel));
}